      SUBROUTINE AGS0D1(N,KL,KR,MMAX,VJ,PJ,FA,FB,SB,EPS0,K3,IP,W,D,E,
     1                  E2,S,RR,LO,IR,TETA,T2,BS,TETA2,BS2,TAU,TAU1,
     2                  TETA1,BS1,V,Y)
         INTEGER IP,IR,K3,KL,KR,MMAX,N
         DOUBLE PRECISION BS,BS1,BS2,D,E,E2,EPS0,PJ,RR,S,T2,TAU,TAU1,
     1                    TETA,TETA1,TETA2,VJ,W,V,Y
         LOGICAL LO
         DIMENSION BS(K3),BS1(1),BS2(K3),D(MMAX),E(MMAX),E2(MMAX),
     1             IR(K3),LO(MMAX),PJ(N),RR(1),S(MMAX,K3),T2(K3),
     2             TAU(K3),TAU1(K3),TETA(K3),TETA1(1),TETA2(K3),VJ(N),
     3             W(N),V(N,MMAX),Y(N,K3)
         EXTERNAL AES0D0,AV04D1,AVZ6D,AM05D,FA,FB,SB
         INTEGER I,I0,I1,I2,I3,I4,I5,I6,IGR,IGR2,IP0,J,JL,JR,K1,L,
     1           L1,L2,L3,L4,M,M1,ML,ML0,ML1,MR,NG,NG0,NG2,
     2           NUM
         DOUBLE PRECISION ALFA,AV04D1,BETA,BETA1,
     1                    ENJ2,EPS,EPS1,EPS10,EPS2,EPS3,EPS4,ER,F,G,R,
     2                    R1,RM,SIGMA,SYS020,RELMCH,TETAM,EPS31
         LOGICAL LOG
         DATA RELMCH/1.111307226797642D-16/, 
     1        SYS020/0.693147180559945309D0/
       EPS2 = DSQRT(RELMCH)
       R = DLOG(DFLOAT(N))/SYS020
       EPS10 = EPS2*R/2.D0
       EPS4 = RELMCH*R
       L1 = MMAX + 1
       L2 = L1 + MMAX
       L3 = L2 + MMAX
       L4 = L3 + MMAX
       K1 = KR + KL
       I0 = IP
       IP = 0
    5  CALL FB(VJ,PJ,N)
       R = DSQRT(AV04D1(VJ,PJ,N))
       IF (R .NE. 0.D0) GO TO 20
        DO 10 I = 1, N
         VJ(I) = 1.D0
   10   CONTINUE
        GO TO 5
   20  CONTINUE
       F = 1.D0/R
       DO 30 I = 1, N
        PJ(I)=PJ(I)*F
        W(I) = 0.D0
        VJ(I) = VJ(I)*F
   30  CONTINUE
       BETA1 = 0.D0
       ML = 1
       MR = 0
       NG2 = 0
       SIGMA = 0.D0
       IP0 = 0
       ENJ2 = 0.0D0
       TETAM = 1.D0
       EPS = EPS0/2.D0
       EPS3 = EPS4*TETAM
       EPS31 = EPS4
       DO 650 J = 1, MMAX
        DO 35 I=1,N
         V(I,J)=VJ(I)
   35   CONTINUE
        IP1=0
        CALL FA(VJ,W,N)
        ALFA = AV04D1(W,VJ,N)
        E(J) = BETA1
        E2(J) = BETA1*BETA1
        D(J)=ALFA
        IF(J.EQ.MMAX)GO TO 660
        DO 40 I = 1, N
         W(I) = W(I) - ALFA*PJ(I)
   40   CONTINUE
        CALL SB(W,VJ,N)
        J1=J+1
        DO 45 I=1,N
        V(I,J1)=VJ(I)
   45   CONTINUE
        BETA = DSQRT(AV04D1(W,VJ,N))
   50   R=EPS10 * TETAM
        EPS1 = DMAX1(R,EPS3)
        IF(BETA .LE. EPS31*TETAM) IP0 = 4
        IF(EPS1. GT. R*128.D0) IP0 = 5
        IF (BETA .LE. EPS1 .AND. J .GT. K3) IP0 = 2
        IF (IP0 .NE. 0) GO TO 670
        IF(BETA.LE.EPS.AND.J.GT.K1.AND.I0.EQ.0)GO TO 670
        IF (BETA .GT. EPS3) GO TO 60
           ML = J
           MR = 0
   60     CONTINUE
          NG = 0
          ML0 = 1
          LOG = .TRUE.
          IF (J .LT. K1 .OR. I0 .EQ. 1) LOG = .FALSE.
   70    CONTINUE
         M = ML + MR
         NUM = ML0 - 1
         IR(ML0) = 0
         IF (M .GT. K3) IP0 = 2
         IF (IP0 .EQ. 2) GO TO 670
          CALL AES0D0(D,E,E2,RR,RR(L1),RR(L2),RR(L3),
     1                RR(L4),LO,J,ML0,ML,NUM,TETA,S,MMAX,IR)
          DO 80 I = ML0, ML
           R = DABS(S(J,I))*BETA
           BS(I) = R
           IF (R .LE. EPS1) NG = NG + 1
           IF (I .GT. KL) GO TO 80
            IF (R .GT. EPS) LOG = .FALSE.
   80     CONTINUE
          IF (MR .EQ. 0) GO TO 120
           IF (M .EQ. J) GO TO 90
            IF (BS(ML) .GT. EPS1 .AND. ( .NOT. LOG .OR. ML .GE. KL))
     1         GO TO 90
             ML = ML + 1
             ML0 = ML
             GO TO 70
   90      CONTINUE
           ML1 = ML + 1
           IF (MR .EQ. 0) GO TO 120
            M1 = ML1
            JR = J
            JL = J - MR + 1
  100      CONTINUE
           NUM = M1 - 1
           IR(M1) = 0
           CALL AES0D0(D,E,E2,RR,RR(L1),RR(L2),RR(L3),
     1                 RR(L4),LO,J,JR,JL,NUM,TETA,S,MMAX,IR)
           DO 110 I = M1, M
            R = DABS(S(J,I))*BETA
            BS(I) = R
            IF (R .LE. EPS1) NG = NG + 1
            IF (I .GT. ML + KR) GO TO 110
             IF (R .GT. EPS) LOG = .FALSE.
  110      CONTINUE
           IF (M .EQ. J) GO TO 120
            IF (BS(M) .GT. EPS1 .AND. ( .NOT. LOG .OR. MR .GE. KR))
     1         GO TO 120
             M = M + 1
             IF (M .GT. K3) IP0 = 2
             IF (IP0 .EQ. 2) GO TO 670
              M1 = M
              JL = JL - 1
              MR = MR + 1
              JR = JL
              GO TO 100
  120       CONTINUE
            IF(ML .LT. KL .OR. MR .LT. KR) GO TO 125
            IF (LOG) GO TO 670
  125       IF (MR .EQ. 0) ML1 = M
            TETAM = DMAX1(DABS(TETA(1)),DABS(TETA(ML1)),TETAM)
            IF (NG .NE. 0) GO TO 130
             IF (NG2 .EQ. 0) BETA1 = BETA
             IF (NG2 .EQ. 0) GO TO 540
              NG = NG2
              GO TO 360
  130       CONTINUE
            NG = NG2
            IF (MR .EQ. 0) GO TO 160
             DO 140 I = ML1, M
              I1 = M + ML1 - I
              RR(I) = BS(I1)
  140        CONTINUE
             DO 150 I = ML1, M
              BS(I) = RR(I)
              I1 = M + ML1 - I
              RR(I) = TETA(I1)
  150        CONTINUE
  160       CONTINUE
            DO 170 I = 1, ML
             RR(I) = TETA(I)
  170       CONTINUE
            IF (NG2 .EQ. 0) GO TO 190
             DO 180 I = 1, NG2
              T2(I) = TETA2(I)
  180        CONTINUE
             CALL AVZ6D(T2,NG2,IR)
  190       CONTINUE
            NG0 = 0
            I2 = 0
            DO 340 I = 1, M
             IF (I .LE. I2) GO TO 340
              IF (BS(I) .GT. EPS1) GO TO 340
               R = RR(I)
               IGR = 1
               I1 = I
               I2 = I
               IF (I1 .EQ. M) GO TO 210
                I5 = I1 + 1
                DO 200 I3 = I5, M
                 R1 = RR(I3)
                 IF (DABS(R1-R) .GT. EPS1) GO TO 210
                  I2 = I2 + 1
                  IF (BS(I3) .GT. EPS1) GO TO 200
                   IGR = IGR + 1
  200            CONTINUE
  210           CONTINUE
                IGR2 = 0
                IF (NG0 .EQ. NG2) GO TO 230
                 I5 = NG0 + 1
                 DO 220 I3 = I5, NG2
                  R1 = T2(I3)
                  IF (DABS(R1-R) .GT. EPS1) GO TO 220
                   IGR2 = IGR2 + 1
                   NG0 = I3
  220            CONTINUE
  230           CONTINUE
                IF (IGR .LE. IGR2) GO TO 340
                 DO 330 I6 = I1, I2
                  IF (BS(I6) .GT. EPS1) GO TO 330
                   I4 = I6
                   IF (I4 .GT. ML) I4 = M + ML1 - I4
                   DO 240 I3 = 1, N
                    VJ(I3) = 0.D0
  240              CONTINUE
                   DO 270 I5 = 1, J
                     G = S(I5,I4)
                     DO 250 I3 = 1, N
                      VJ(I3) = VJ(I3) + V(I3,I5)*G
  250                CONTINUE
  270              CONTINUE
                    IF (NG .EQ. 0) GO TO 300
                     CALL FB(VJ,W,N) 
                     DO 290 L = 1, NG
                       G = AV04D1(W,Y(1,L),N)
                       DO 280 I3 = 1, N
                        VJ(I3) = VJ(I3) - G*Y(I3,L)
  280                  CONTINUE
  290                CONTINUE
  300               CONTINUE
                    CALL FB(VJ,W,N)
                    R = DSQRT(AV04D1(VJ,W,N))
                    IF (R .LE. 1.D0/(2.D0*DSQRT(I2-I1+1.D0)))
     1                 GO TO 330
                     F = 1.D0/R
                     NG=NG+1
                     IF(IP1.EQ.0)IP1=1
                     DO 310 I3 = 1, N
                      R=VJ(I3)*F
                      VJ(I3) = R
                      Y(I3,NG) = R
                      PJ(I3) = 0.D0
  310                CONTINUE
                     CALL FA(VJ,PJ,N)
                     R = AV04D1(VJ,PJ,N)
                     R1=R*F
                     DO 320 I3 = 1, N
                      PJ(I3) = PJ(I3) - R1*W(I3)
  320                CONTINUE
                     ER = DSQRT(AV04D1(PJ,PJ,N))
                     BS2(NG) = ER
                     TETA2(NG) = R
                     TAU(NG) = -1.D0
  330              CONTINUE
  340            CONTINUE
  350            CONTINUE
                 IF (NG .EQ. 0) BETA1 = BETA
                 IF (NG .EQ. 0) GO TO 540
  360            CONTINUE
                  IGR = NG - NG2
                  IF (NG2 .EQ. 0) GO TO 400
                   DO 390 I = 1, NG2
                    R = TAU(I)
                    R1 = R
                    IF (R1 .LE. -1.D0) R = RM
                    IF (R1 .EQ. -1.D0) TAU(I) = -2.D0
                    IF (R1 .EQ. -1.D0) GO TO 370
                     TAU(I) = (R*DABS(TETA2(I)-ALFA) + TAU1(I)*
     1                        BETA1 + 3.D0*RELMCH*TETAM)/BETA
                     IF (TAU(I) .LE. EPS2) GO TO 380
                      TAU(I) = -1.D0
  370                CONTINUE
                     IGR = IGR + 1
  380               CONTINUE
                    TAU1(I) = R
  390              CONTINUE
  400             CONTINUE
                  IGR2 = 0
                  DO 405 I=1,N
                   VJ(I)=V(I,J1)
  405             CONTINUE
                  CALL FB(VJ,W,N)
                  DO 420 I1 = 1, NG
                   IF (IGR2 .EQ. IGR) GO TO 430
                    IF (TAU(I1) .GT. -1.D0) GO TO 420
                     G = AV04D1(W,Y(1,I1),N)
                     IGR2 = IGR2 + 1
                     IF (DABS(G) .LE. (RELMCH*BETA)) GO TO 420
                      DO 410 I = 1, N
                      VJ(I) =VJ(I) - G*Y(I,I1)
  410                 CONTINUE
                      G = G*G
                      ENJ2 = ENJ2 + G
  420               CONTINUE
  430              CONTINUE
                   CALL FB(VJ,W,N)
                   BETA1 = DSQRT(AV04D1(VJ,W,N))
                   R = DSQRT(ENJ2)
                   EPS3 = DMAX1(EPS3,R)
                   EPS = DMAX1(EPS,EPS3)
                   IF (BETA1 .GT. EPS3) GO TO 530
                    IF (BETA1 .LE. EPS31*TETAM) IP0 = 4
                    IF (IP0 .EQ. 4) GO TO 670
                    IF (BETA1/BETA .GE. 0.5D0) GO TO 530
                    DO 440 I1 = 1,NG
                     TAU(I1) = -1.D0     
  440               CONTINUE
                     BETA = BETA1
                     NG2 = NG
                     GO TO 50
  530            CONTINUE
                 RM = EPS4*BETA/BETA1
  540           CONTINUE
                F = 1.D0/BETA1
                IF(IP1.EQ.1)GO TO 554
                DO 550 I = 1, N
                 R=W(I)
                 W(I) = PJ(I)*BETA1
                 PJ(I) = R*F
                  VJ(I) = VJ(I)*F
  550           CONTINUE
                GO TO 557
  554           DO 555 I=1,N  
                VJ(I)=VJ(I)*F
                PJ(I)=W(I)*F    
  555           CONTINUE
                CALL FB(V(1,J),W,N)
                DO 556 I=1,N
                W(I)=W(I)*BETA1
  556           CONTINUE
  557              IF (MR .NE. 0) GO TO 580
                 IF (M .EQ. 1) GO TO 570
                  M1 = M - 1
                  DO 560 I = 1, M1
                   IF (BS(I) .LE. EPS1) GO TO 560
                    IF (BS(I+1) .LE. EPS1) GO TO 560
                     ML = I
                     MR = J - ML
                     GO TO 580
  560             CONTINUE
  570            CONTINUE
                 ML = J + 1
  580           CONTINUE
  640             CONTINUE
                  NG2 = NG
  650            CONTINUE
  660           CONTINUE
                J = MMAX
                IP0 = 1
  670          CONTINUE
               ML = KL
               MR = KR
               IF (J .LT. K1) ML = J
               IF (J .LT. K1) MR = 0
               M = ML + MR
               ML1 = ML + 1
               IR(1) = 0
               IF (ML .NE. 0)
     1            CALL AES0D0(D,E,E2,RR,RR(L1),RR(L2),RR(L3),RR(L4),
     2                        LO,J,1,ML,0,TETA,S,MMAX,IR)
               JL = J - MR + 1
               IR(ML1) = 0
               IF (MR .NE. 0)
     1            CALL AES0D0(D,E,E2,RR,RR(L1),RR(L2),RR(L3),RR(L4),
     2                        LO,J,J,JL,ML,TETA,S,MMAX,IR)
               IF (EPS0 .LT. EPS .AND. IP0 .EQ. 0) IP0 = 3
               IP = 0
               DO 760 I = 1, M
                CALL AM05D(V,S(1,I),W,N,J)
               CALL FB(W,PJ,N)
               F = 1.D0/DSQRT(AV04D1(W,PJ,N))
               DO 740 I3 = 1, N
                VJ(I3) = W(I3)*F
                W(I3) = 0.D0
  740          CONTINUE
               CALL FA(VJ,W,N)
               R = AV04D1(VJ,W,N)
               R1=R*F
               DO 750 I3 = 1, N
                W(I3) = W(I3) - R1*PJ(I3)
                Y(I3,I) =VJ(I3)
  750          CONTINUE
               CALL SB(W,PJ,N) 
               ER = DSQRT(AV04D1(W,PJ,N))
               BS1(I) = ER
               TETA1(I) = R
               IF (ER .GT. EPS0) IP =IP0
  760         CONTINUE
  770        CONTINUE
             IF (J .LT. K1) IP =IP0
             IF (I0 .EQ. 1 .AND. J .NE. MMAX) IP =IP0
             IF(IP0 .EQ. 4) IP = 4
             RR(1) = DFLOAT(J)
             RETURN
      END
