      SUBROUTINE AES0D0(A,B,B2,D,E,F,Y,Z,LOG,N,M1,M2,NUM,EV,V,MM,NIT)
         INTEGER M1,M2,N,NIT,NUM
         DOUBLE PRECISION A,B,B2,D,E,EV,F,V,Y,Z
         LOGICAL LOG
         DIMENSION A(N),B(N),B2(N),D(N),E(N),EV(1),F(N),LOG(N),NIT(1),
     1             V(MM,1),Y(N),Z(N)
         EXTERNAL AV02D,AV04D
         INTEGER I,I1,I2,I3,IJ,IP,IT,J,J1,J2,J21,K,L,M,MET,NJ,NUM1,
     1           NUM2
         DOUBLE PRECISION ALFA,AV02D,AV04D,BI,DI,EI,EPS,EPS1,EPS2,EVM,
     1                    G,R,SNORM,SYS051,SYS056,T,U,W,WM,X,XL,XL0,
     2                    XU,XU0
         DATA SYS051/1.1107652D-16/,SYS056
     1        /5.56268464627D-308/
       IF (N .NE. 1) GO TO 10
        EV(1) = A(1)
        V(1,1) = 1.D0
        GO TO 420
   10  CONTINUE
       IF (M1 .LE. M2) GO TO 30
        J1 = N - M1 + 1
        J2 = N - M2 + 1
        DO 20 I = 1, N
          D(I) = -A(I)
          E(I) = -B(I)
   20   CONTINUE
        GO TO 50
   30  CONTINUE
       J1 = M1
       J2 = M2
       DO 40 I = 1, N
         D(I) = A(I)
         E(I) = B(I)
   40  CONTINUE
   50  CONTINUE
       M = IABS(M1-M2) + 1
       DI = D(1)
       XU = DI
       XL = DI
       R = 0.D0
       DO 60 I = 2, N
         EI = DABS(E(I))
         W = R + EI
         XU = DMAX1(XU,DI+W)
         XL = DMIN1(XL,DI-W)
         DI = D(I)
         R = EI
   60  CONTINUE
       XU0 = DMAX1(XU,DI+EI)
       XL0 = DMIN1(XL,DI-EI)
       EVM = DMAX1(DABS(XU0),DABS(XL0))
       T = 2.D0*SYS051
       EPS = EVM*SYS051
       EPS = DMAX1(EPS,SYS056)
       WM = DMAX1(EPS/(2.D0*N*SYS056),1.D0)
       DO 70 I = 1, N
         IF (DABS(E(I)) .GT. EPS) GO TO 70
          E(I) = 0.D0
          B2(I) = 0.D0
   70  CONTINUE
       NUM1 = NUM + 1
       NUM2 = NUM + M
       IP = NIT(NUM1)
       IF (IP .EQ. -2) EPS = DMAX1(EPS,F(1))
       IF (IP .GT. 0) GO TO 200
        B2(1) = 0.D0
        L = M + NUM
        J = J2
        ASSIGN 170 TO MET
        XL = XL0
   80  CONTINUE
       XU = XU0
       NJ = N - J + 1
   90  CONTINUE
       X = (XU + XL)*0.5D0
       IF ((XU - XL) .LE. ((DABS(XU)+DABS(XL))*T + EPS)) GO TO 160
        K = 0
        U = 1.D0
        IJ = 0
        DO 130 I = 1, N
          IF (U .NE. 0.D0) GO TO 100
           W = DABS(E(I))/SYS051
           GO TO 110
  100    CONTINUE
         W = B2(I)/U
  110    CONTINUE
         U = D(I) - X - W
         IF (U .LT. 0.D0) GO TO 120
          IJ = IJ + 1
          IF (IJ .EQ. NJ) GO TO 140
           GO TO 130
  120    CONTINUE
         K = K + 1
         IF (K .EQ. J) GO TO 150
  130  CONTINUE
  140  CONTINUE
       XL = X
       GO TO 90
  150  CONTINUE
       XU = X
       GO TO 90
  160  CONTINUE
       EV(L) = X
       GO TO MET,(170,180)
  170  CONTINUE
       XU0 = XU
       XL = XL0
       ASSIGN 180 TO MET
       IF (M .EQ. 1) GO TO 200
        J21 = J2 - 1
        L = NUM
        DO 180 J = J1, J21
          L = L + 1
          GO TO 80
  180  CONTINUE
       IF (M1 .LE. M2) GO TO 200
        DO 190 I = NUM1, NUM2
          EV(I) = -EV(I)
  190   CONTINUE
  200  CONTINUE
       IF (IP .LE. -1) GO TO 420
        EPS1 = EPS*10.D0*N*DSQRT(DFLOAT(N))
        EPS2 = EVM*1.D-3
        K = 0
        J1 = NUM
        DO 410 J = NUM1, NUM2
          X = EV(J)
          U = A(1) - X
          W = B(2)
          DO 220 I = 2, N
            BI = B(I)
            LOG(I) = (DABS(BI) .GT. DABS(U))
            IF (LOG(I)) GO TO 210
             IF (DABS(U) .LE. EPS) U = EPS
             R = BI/U
             Y(I) = R
             D(I-1) = U
             E(I-1) = W
             F(I-1) = 0.D0
             U = A(I) - X - R*W
             IF (I .NE. N) W = B(I+1)
             GO TO 220
  210      CONTINUE
           R = U/BI
           Y(I) = R
           D(I-1) = BI
           E(I-1) = A(I) - X
           IF (I .NE. N) F(I-1) = B(I+1)
           U = W - R*E(I-1)
           W = -R*F(I-1)
  220    CONTINUE
         IF (DABS(U) .LE. EPS) U = EPS
         D(N) = U
         E(N) = 0.D0
         F(N-1) = 0.D0
         F(N) = 0.D0
         IT = 0
         IF (IP .EQ. 2) GO TO 240
          DO 230 I = 1, N
            Z(I) = 1.D0
  230     CONTINUE
          GO TO 310
  240    CONTINUE
         DO 250 I = 1, N
           Z(I) = V(I,J)
  250    CONTINUE
         GO TO 280
  260    CONTINUE
         DO 270 I = 1, N
           Z(I) = 0.D0
  270    CONTINUE
         IF (K .EQ. N) K = 0
         K = K + 1
         Z(K) = 1.D0
         DO 300 I = 2, N
  280      CONTINUE
           IF (LOG(I)) GO TO 290
            Z(I) = Z(I) - Y(I)*Z(I-1)
            GO TO 300
  290      CONTINUE
           U = Z(I-1)
           Z(I-1) = Z(I)
           Z(I) = U - Y(I)*Z(I)
  300    CONTINUE
  310    CONTINUE
         ALFA = 1.D0
         DO 340 I2 = 1, N
           I = N + 1 - I2
           R = 1.D0
           G = ALFA*Z(I) - U*E(I) - W*F(I)
           DI = D(I)
           IF (DABS(G) .LE. WM) GO TO 330
            R = DI/G
            Z(I) = 1.D0
            ALFA = R*ALFA
            I1 = I + 1
            U = 1.D0
            IF (I .EQ. N) GO TO 340
             DO 320 I3 = I1, N
               Z(I3) = Z(I3)*R
  320        CONTINUE
             W = Z(I+1)
             GO TO 340
  330      CONTINUE
           R = G/DI
           Z(I) = R
           W = U
           U = R
  340    CONTINUE
         IT = IT + 1
         IF (J1 .EQ. 0) GO TO 370
          DO 360 J2 = 1, J1
            IF (DABS(X-EV(J2)) .GT. EPS2) GO TO 360
             G = AV04D(Z,V(1,J2),N)
             DO 350 I = 1, N
               Z(I) = Z(I) - G*V(I,J2)
  350        CONTINUE
  360     CONTINUE
  370    CONTINUE
         SNORM = 0.D0
         DO 380 I = 1, N
           SNORM = SNORM + DABS(Z(I))
  380    CONTINUE
         IF (SNORM .EQ. 0.D0) GO TO 260
          R = DABS(ALFA)/SNORM
          IF (R .LE. EPS1) GO TO 390
           IF (R .GE. 0.1D0) GO TO 260
            GO TO 280
  390     CONTINUE
          G = 1.D0/AV02D(Z,N)
          DO 400 I = 1, N
            V(I,J) = Z(I)*G
  400     CONTINUE
          NIT(J) = IT
          J1 = J
  410   CONTINUE
  420  RETURN
      END
